
#include <SoftwareSerial.h>

SoftwareSerial mySerial(10, 11); // RX, TX
char msg_to_send[] = "Hello Server!";
char buf[100];

#define SSID        "iot_tplink" //AP ssid
#define PWD         "" //AP password
#define DST_ADDR    "192.168.1.100" //UDP server address
#define DST_PORT    "5000" //UDP server port

void setup() {
  // Open serial communications and wait for port to open:
  Serial.begin(57600);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }

  Serial.println("\r\nHello World!\r\n");

  // set the data rate for the SoftwareSerial port
  mySerial.begin(38400);

  // wait for AT command ready
  delay(1000);

  // reset Ameba
  mySerial.println("ATSR");
  delay(2000);
  
  // query AT ready or not
  mySerial.println("AT");
  delay(1000);
  Serial.println("\r\nAT ready!\r\n");
  
  // turn off uart echo
  mySerial.println("ATSE=0");
  delay(20);

  // wifi connect to "iot_newifi"
  mySerial.println("ATPN=" SSID "," PWD);
  delay(5000);
  Serial.println("\r\nConnect to iot_newifi!\r\n");
  
  // start udp client with dst_addr "192.168.99.185" and dst_port 5001
  mySerial.println("ATPC=1," DST_ADDR "," DST_PORT);
  delay(3000);
  Serial.println("\r\nStart udp client!\r\n");

  // the first con_id is 1
  char con_id = 1;
  
  // prepare udp data to send
  sprintf(buf, "ATPT=%d,%d:%s", strlen(msg_to_send), con_id, msg_to_send);
  Serial.println("\r\nReady to send data, please check udp server!\r\n");
}

void loop() { // run over and over
  // send data every second
  mySerial.print(buf);
  delay(1000);
}
